function [H,f_x,gg_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s]=...
    H_MACH3(x,ini_x,t,length_I,ini_y,ini_g,y,max_g,g_need,I_need,b,g0)

global theta cl cr

f_x=obj_grad(x);
t_theta=t*theta;
g_i_x=con_grad(x,I_need,length_I);
g_max=max(max_g,g0);

g_s=(g_need+cr*b)/cl/b;%     g_s=(g_need+/b;
[alpha,grad_s]=phi(g_s);
term_exp=exp(([g_need;g0]-g_max)/t_theta);
term_sum=sum([alpha;1].*term_exp);
g_a  = t_theta*log(term_sum)+g_max;

lambda=alpha.*term_exp(1:end-1)/term_sum;
gg_x = g_i_x*lambda;

H  = [(1-t)*(f_x+y*gg_x)+t*(x-ini_x); y*g_a-t*ini_y*ini_g];
return