function  [x,x0,y,y0,t,t0,k,flag_cor,flag_pre]=Newton(first_x,first_y,first_t,d,m_max,epison,x,y,t,step)

% Newton correct to solve H=0 and & d'[z-first_z; t-first_t]=0

global  nv  dim_g ini_x ini_y ini_g num_smooth

k=0;flag_pre=1;
% initial point
x1=first_x; y1=first_y;t1=first_t;x0=[];y0=[];t0=0;g=con_fun(x1);
% % % % % % %

global  al ar cl cr
b=al*t1+ar;
g0=-cr*b;
I_need=find(g>-b);
length_I=length(I_need) ;
if length_I>0
    g_need=g(I_need);
    max_g=max(g_need);
    [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s]=...
        H_MACH(x1,ini_x,t1,length_I,ini_y,ini_g,y1,max_g,g_need,I_need,b,g0);
    if g_a>1e-6
        flag_cor=0;
        return
    end
    [DH]=DH_MACH(f_x,x1,ini_x,t1,nv,length_I,y1,ini_y,ini_g,g_x,g_need,I_need,...
        g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,b,g0);
    num_smooth=num_smooth+length_I;
    
else
    g_a=g0;%%%????????????????
    f_x=obj_grad(x1);
    x1_ini_x_f_x=x1-ini_x-f_x;
    H=[f_x+t1*x1_ini_x_f_x;y1*g0-t1*ini_y*ini_g];
    f_xx=obj_hes(x1);
    DH = [(1-t1)*f_xx+t1*eye(nv)  zeros(nv,1)    x1_ini_x_f_x
        zeros(1,nv)               g0             -y1*al*cr-ini_y*ini_g];
end

while 1
    h=-[DH;d']\[H;0];
    k=k+1;
    nh=norm(h);
    t2=t1+h(end);
    if t2>1
        flag_cor=0;
        return
    end
    if t2<0
        if nh>nv
            flag_cor=0;
            return
        else
            step_t=-t1/h(end);
            x0=x1+step_t*h(1:nv);
            g=con_fun(x0);
            if max(g)>1&meth<8,flag_cor=0;return,end
            y0=y1+step_t*h(nv+1:end-1);
            flag_pre=0;flag_cor=0;
            return
        end
    else
        y2=y1+h(nv+1:end-1);
        x2=x1+h(1:nv);
    end
    g=con_fun(x2);
    if max(g)>0
        flag_cor=0;
        return
    end
    
    b=al*t2+ar;
    g0=-cr*b;
    I_need=find(g>-b);
    length_I=length(I_need);
    if length_I>0
        g_need=g(I_need);
        max_g=max(g_need);
        [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s]=...
            H_MACH(x2,ini_x,t2,length_I,ini_y,ini_g,y2,max_g,g_need,I_need,b,g0);
    else
        f_x=obj_grad(x2);
        x2_ini_x_f_x=x2-ini_x-f_x;
        H=[f_x+t2*x2_ini_x_f_x;y2*g0-t2*ini_y*ini_g];
    end
    
    
    nf=norm(H,inf);
    if  nh<epison&nf<epison
        flag_cor=2;
        x=x2;y=y2;t=t2;
        return
    else
        x1=x2;y1=y2; t1=t2;
    end
    
    if k==m_max
        flag_cor=1;
        return
    end
    if length_I>0
        [DH]=DH_MACH(f_x,x2,ini_x,t2,nv,length_I,y2,ini_y,ini_g,g_x,g_need,I_need,...
            g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,b,g0);
        num_smooth=num_smooth+length_I;
    else
        f_xx=obj_hes(x2);
        DH = [(1-t2)*f_xx+t2*eye(nv)  zeros(nv,1)    x2_ini_x_f_x;
            zeros(1,nv)               g0             -y2*al*cr-ini_y*ini_g;];
    end
    
end