function hes_f=obj_hes(x)

global nv  pro
switch pro
    
    case 1
        hes_f=2*eye(nv);
    case 2
        hes_f=2*[0 0 0 0
            0 0 0 0
            0 0 1 0
            0 0 0 1];
    case 3
        global nv
        hes_f=2*eye(nv)/nv;
    case 4
        hes_f=spdiags(zeros(2,1),0,2,2);
    case 5
        hes_f=spdiags(zeros(1000,1000));
        hes_f(1,1:2)=[-sin(x(1)-1+pi*1.5)+200*cos(-x(2)+1.5*pi+x(1)^2)-400*sin(-x(2)+1.5*pi+x(1)^2)*x(1)^2 200*sin(-x(2)+1.5*pi+x(1)^2)*x(1)];
        for i=2:999
            hes_f(i,i-1:i+1)=[200*sin(-x(i)+1.5*pi+x(i-1)^2)*x(i-1) ...
                -100*sin(-x(i)+1.5*pi+x(i-1)^2)+200*cos(-x(i+1)+1.5*pi+x(i).^2)-400*sin(-x(i+1)+1.5*pi+x(i)^2).*x(i)^2 ...
                200*sin(-x(i+1)+1.5*pi+x(i)^2).*x(i)];
        end
        hes_f(1000,999:1000)=100*sin(-x(1000)+1.5*pi+x(999)^2)*[2*x(999) -1];
    case 6
        %         f=(x(1)-2*x(2)+5*x(2)^2-x(2)^3-13)^2+(x(1)-14*x(2)+x(2)^2+x(2)^3-29)^2;
        %         grad_f=[4*x(1)+12*x(2)^2-32*x(2)-84
        %                 2*(x(1)-2*x(2)+5*x(2)^2-x(2)^3-13)*(-2+10*x(2)-3*x(2)^2)+2*(x(1)-14*x(2)+x(2)^2+x(2)^3-29)*(-14+2*x(2)+3*x(2)^2)];
        four= 2*(x(1)-2*x(2)+5*x(2)^2-x(2)^3-13)*(10-6*x(2))+2*(-2+10*x(2)-3*x(2)^2)^2+2*(x(1)-14*x(2)+x(2)^2+x(2)^3-29)*(2+6*x(2))+2*(-14+2*x(2)+3*x(2)^2)^2;
        hes_f=[4            24*x(2)-32
            24*x(2)-32   four];

        %
        %        hes_f=zeros(2,2);
        %         hes_f=[2.25 0;0 1]*[exp(x(1)) 0;0 exp(x(2))];
        %         hes_f=spdiags(zeros(4,1),0,4,4);
    case 7
        hes_f=[2/3   0
            0     2];
        %        hes_f=spdiags(zeros(3,1),0,3,3);
    case 8
        hes_f=2*eye(3);
    case 9
        global bt tt
        %         f=sum(bt.*log(x(1:tt)));
        hes_f=sparse(nv,nv);
        hes_f(1:tt,1:tt)=spdiags(-bt./x(1:tt).^2,0,tt,tt);
    case 10
        %         f=sin(x(1)-1+1.5*pi)+100*sum(sin(-x(2:end)+1.5*pi+x(1:end-1)^2));
        %         grad_f=[sin(x(1)-1+1.5*pi)
        %             -200*cos(-x(2:end)+1.5*pi+x(1:end-1)^2)]...
        %             +[200*x(1:end-1).*cos(-x(2:end)+1.5*pi+x(1:end-1)^2);0];
        a_ii=[cos(x(1)-1+1.5*pi);-200*sin(-x(2:end)+1.5*pi+x(1:end-1).^2)]+[200*cos(-x(2:end)+1.5*pi+x(1:end-1).^2)-400*x(1:end-1).^2.*sin(-x(2:end)+1.5*pi+x(1:end-1).^2);0];
        a_ii1=400*x(1:end-1).*sin(-x(2:end)+1.5*pi+x(1:end-1).^2);
        %        size(a_ii)
        %        size(a_ii1)
        %        spdiags(a_ii,0,1000,1000);  spdiags(a_ii1,1,1000,1000)
        %        spdiags(a_ii1,-1,1000,1000);

        hes_f=spdiags(a_ii,0,1000,1000)+spdiags(a_ii1,-1,1000,1000)+spdiags(a_ii1,-1,1000,1000)';
    case 11
        global par_t
        %       f=-.5*sum(x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)));
        %         grad_f=-.5*([x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t,1)]...
        %                   +[0;x(1:par_t-2).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t-1,1)]...
        %                   +[zeros(par_t-1,1);-x(1:par_t-2).*x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));0]...
        %                   +[zeros(par_t,1);x(1:par_t-2).*x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))]);
        %            hes_f=-0.5*(spdiags([sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t-1,1)],-1,2*par_t-2,2*par_t-2)'...
        %                      +spdiags([sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t-1,1)],-1,2*par_t-2,2*par_t-2)...
        %                      +spdiags([zeros(par_t-1,1);x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))],-1,2*par_t-2,2*par_t-2)'...
        %                      +spdiags([zeros(par_t-1,1);x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))],-1,2*par_t-2,2*par_t-2));

        %               a13=sparse(49,49)    x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))
        %               a14=sparse(49,49)    -x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))
        %               a23=sparse(49,49)    x(1:par_t-2).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))
        %               a24=sparse(49,49)
        %               -x(1:par_t-2).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))
        hes_f(1:par_t-1,1:par_t-1)=-0.5*(spdiags(sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1)'...
            +spdiags(sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1));
        hes_f(par_t:2*par_t-2,par_t:2*par_t-2)=-0.5*(spdiags(x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1)'...
            +spdiags(x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1)...
            +spdiags(-[x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));0]...
            -[0;x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))],0,par_t-1,par_t-1));
        %           hes_f(1:par_t-1,par_t:2*par_t-2)=-0.5*(spdiags(x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1)...
        %                                                 -spdiags([x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));0],0,par_t-1,par_t-1);
        %           hes_f(par_t:2*par_t-2,1:par_t-1)=hes_f(1:par_t-2,par_t:2*par_t-2)';
        aa=spdiags(x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1)'+...
            spdiags([-x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));0]+[0;x(1:par_t-2).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))],0,par_t-1,par_t-1)+...
            spdiags(-x(1:par_t-2).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)),-1,par_t-1,par_t-1);
        hes_f(1:par_t-1,par_t:2*(par_t-1))=-0.5*aa;
        hes_f(par_t:2*(par_t-1),1:par_t-1)=-0.5*aa';
    case 12
        global nv
        hes_f=speye(nv);
    case 13
        global AA 
        hes_f=2*AA;  
    case 14
        hes_f=sparse(nv,nv);
end