function [DH]=DH_MACH3_end(x,nv,length_I,y,gg_x,I_need,g_a,t_theta,g_i_x,term_exp,term_sum,alpha,grad_s,b)
global   ar cl

    f_xx=obj_hes(x);
    
    g_i_xx=con_hes(x,I_need,length_I);
    lambdax=(alpha+(t_theta/cl/ar)*grad_s).*term_exp/term_sum;
    g_x = g_i_x*lambdax;

    term_t=repmat(lambdax',nv,1);
    gg_xx = reshape(g_i_xx*alpha,nv,nv)+(g_i_x.*term_t*g_i_x'-gg_x*g_x')/t_theta;    

    Hx = [f_xx+y*gg_xx; y*g_x'];
    Hy = [gg_x; g_a];
    DH = [Hx Hy];

return