function [x,y,H,k,err]=Newton_fix_t(first_x,first_y,t,t_small,m_max,epison,x,y)

% Newton correct to solve H=0 and & d'[z-first_z; t-first_t]=0

global  nv dim_g num_smooth
k=0;H=[];nh=[inf,inf];gg=[inf,inf];
err=inf;
% initial point
x1=first_x;
y1=first_y;
% % % % % % %
if t>t_small|t<=0
    t=t_small;
end
n=nv+1;
g=con_fun(x1);
g_max=max(g);
if g_max>1e-6, return; end
global al ar  cl cr
b=-ar;
g0=-cr*ar;
if g_max>-ar
    I_need=find(g>-ar);
    length_I=length(I_need);
    g_need=g(I_need);
    max_g=max([g_need;g0]);
    [H,f_x,g_x,g_a,t_theta,g_i_x,term_exp,term_sum,alpha,grad_s]=...
        H_MACH_end(x1,t,length_I,y1,max_g,g_need,I_need,b);
    [DH]=DH_MACH_end(x1,nv,length_I,y1,g_x,I_need,g_a,t_theta,g_i_x,term_exp,term_sum,alpha,grad_s,b);
    num_smooth=num_smooth+length_I;
else
    I_need=[];length_I=0;
    H=obj_grad(x1); DH=obj_hes(x1);
end

while 1
    h=-DH\H;
    k=k+1;
    nh=[norm(h),nh(1)];
    if nh(1)<10^5
        if nh(1)>nh(2)
            return
        end
        x2=x1+h(1:nv);
        g=con_fun(x2);
        g_max=max(g);
        if g_max>1e-6,
            return
        end
        if  length_I==0
            y2=0;
        else
            y2=y1+h(nv+1:end);
        end
        
        if g_max>-ar
            I_need=find(g>-ar);
            g_need=g(I_need);
            length_I=length(I_need);
            max_g=max([g_need;g0]);
            [H,f_x,g_x,g_a,t_theta,g_i_x,term_exp,term_sum,alpha,grad_s]=...
                H_MACH_end(x2,t,length_I,y2,max_g,g_need,I_need,b);
        else
            I_need=[];length_I=0;
            H=obj_grad(x2);
        end
        nH=norm(H,inf);
        if nH<epison&nh(1)<epison
            if g_max>1e-6&meth<8
                return
            end
            x=x2;y=y2;
            err=nH;
            return
        else
            x1=x2;y1=y2;
        end
        if k==m_max
            if nH<epison&g_max<1e-6
                err=nH;
                x=x2;y=y2;
                return
            end
            return
        end
        if length_I>0
            DH=DH_MACH_end(x2,nv,length_I,y2,g_x,I_need,g_a,t_theta,g_i_x,term_exp,term_sum,alpha,grad_s,b);
            num_smooth=num_smooth+length_I;
        else
            DH=obj_hes(x2);
        end
    else
        return
    end
end
