function grad_f=obj_grad(x)

global pro;
switch pro
    case 1
        grad_f=2*(x-1);
    case 2
        grad_f=2*[0 0 x(3) x(4)]'; 
    case 3
        global nv
        grad_f=2*(x-1)/nv;     
    case 4
        grad_f=[0;1];   
    case 5   
        grad_f=[cos(x(1)-1+pi*1.5)+200*cos(-x(2)+1.5*pi+x(1)^2)*x(1)
            -100*cos(-x(2:999)+1.5*pi+x(1:998).^2)+200*cos(-x(3:1000)+1.5*pi+x(2:999).^2).*x(2:999)
            -100*cos(-x(1000)+1.5*pi+x(999)^2)];
    case 6
        %         f=(x(1)-2*x(2)+5*x(2)^2-x(2)^3-13)^2+(x(1)-14*x(2)+x(2)^2+x(2)^3-29)^2;
        grad_f=[4*x(1)+12*x(2)^2-32*x(2)-84
            2*(x(1)-2*x(2)+5*x(2)^2-x(2)^3-13)*(-2+10*x(2)-3*x(2)^2)+2*(x(1)-14*x(2)+x(2)^2+x(2)^3-29)*(-14+2*x(2)+3*x(2)^2)];
        %         grad_f=2*x;
        %         grad_f=[2;1];
        %         grad_f=[2.25 1]'.*exp(x);
        %         grad_f=[0;0;0;1]; 
    case 7  
        grad_f=[2*x(1)/3+1/2 
            2*x(2)];
        %        grad_f=[0 0 1]';
    case 8
        grad_f=2*x;
        %        grad_f=[0 0 0 0 0 0 1]';
    case 9
        global bt tt nv
        %         f=sum(bt.*log(x(1:tt)));
        grad_f=sparse(nv,1);
        grad_f(1:tt)=bt./x(1:tt);
    case 10
        %         f=sin(x(1)-1+1.5*pi)+100*sum(sin(-x(2:end)+1.5*pi+x(1:end-1)^2));
        grad_f=[sin(x(1)-1+1.5*pi)
            -200*cos(-x(2:end)+1.5*pi+x(1:end-1).^2)]...
            +[200*x(1:end-1).*cos(-x(2:end)+1.5*pi+x(1:end-1).^2);0];
    case 11
        global par_t
%       f=-.5*sum(x(1:par_t-2).*x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3)));
        grad_f=-.5*([x(2:par_t-1).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t,1)]...
                  +[0;x(1:par_t-2).*sin(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));zeros(par_t-1,1)]...
                  +[zeros(par_t-1,1);-x(1:par_t-2).*x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3));0]...
                  +[zeros(par_t,1);x(1:par_t-2).*x(2:par_t-1).*cos(x(par_t+1:2*par_t-2)-x(par_t:2*par_t-3))]);

      case 12
          grad_f=x;
      case 13        
         global AA bb
        grad_f=2*AA*x+bb;  
      case 14
         global cc
         grad_f=cc;
end